# Chapter Three: Understanding Your Bitcoin Setup

You're now ready to begin working with the `bitcoin-cli` command-line interface. But that first requires that you understand your Bitcoin setup and its wallet features, which is what will be explained in this chapter.

For this and future chapters, we presume that you have a VPS with Bitcoin installed, running `bitcoind`. We also presume that you are connected to testnet, allowing for access to bitcoins without using real funds. You can either do this with Bitcoin Standup at Linode.com, per [§2.1: Setting up a Bitcoin-Core VPS with Bitcoin Standup](02_1_Setting_Up_a_Bitcoin-Core_VPS_with_StackScript.md), or via other means, per [§2.2: Setting up a Bitcoin-Core Machine via Other Means](02_2_Setting_Up_Bitcoin_Core_Other.md).

## Objectives for This Chapter

After working through this chapter, a developer will be able to:

   * Demonstrate that Their Bitcoin Node is Installed and Up-to-date
   * Create an Address to Receive Bitcoin Funds
   * Use Basic Wallet Commands
   * Create an Address from a Descriptor
   
Supporting objectives include the ability to:

   * Understand the Basic Bitcoin File Layout
   * Use Basic Informational Commands
   * Understand What a Bitcoin Address Is
   * Understand What a Wallet Is
   * Understand How to Import Addresses
   
## Table of Contents

* [Section One: Verifying Your Bitcoin Setup](03_1_Verifying_Your_Bitcoin_Setup.md)
* [Section Two: Knowing Your Bitcoin Setup](03_2_Knowing_Your_Bitcoin_Setup.md)
* [Section Three: Setting Up Your Wallet](03_3_Setting_Up_Your_Wallet.md)
   * [Interlude: Using Command-Line Variables](03_3__Interlude_Using_Command-Line_Variables.md)
* [Section Four: Receiving a Transaction](03_4_Receiving_a_Transaction.md)
* [Section Five: Understanding the Descriptor](03_5_Understanding_the_Descriptor.md)
