# Chapter Six: Expanding Bitcoin Transactions with Multisigs

Basic bitcoin transactions: (1) send funds; (2) to a single P2PKH or SegWit recipient; (3) from a single machine; (4) immediately. However, all four parts of this definition can be expanded using more complex Bitcoin transactions. This first chapter on "Expansion" shows how to vary points (2) and (3) by sending money to an address that represents multiple recipients (or at least, multiple signers).

## Objectives for This Section

After working through this chapter, a developer will be able to:

   * Create Multisignature Bitcoin Addresses Using Bitcoin Fundamentals
   * Create Multisignature Bitcoin Addresses Using Easier Mechanisms
   
Supporting objectives include the ability to:

   * Understand How to Spend Funds Sent to a Multisignature
   * Plan for the Power of Multisignatures
   
## Table of Contents

   * [Section One: Sending a Transaction with a Multsig](06_1_Sending_a_Transaction_to_a_Multisig.md)
   * [Section Two: Spending a Transaction with a Multsig](06_2_Spending_a_Transaction_to_a_Multisig.md)
   * [Section Three: Sending & Spending an Automated Multisig](06_3_Sending_an_Automated_Multisig.md)
