# Chapter Seven: Expanding Bitcoin Transactions with PSBTs

The previous chapter discussed how to use multisigs to collaboratively determine consent among multiple parties. It's not the only way to collaborate in the creation of Bitcoin transactions. PSBTs are a much newer technology that allow you to collaborate at a variety of stages, including the creation, funding, and authentication of a Bitcoin transaction. 

## Objectives for This Section

After working through this chapter, a developer will be able to:

   * Create Transactions with PSBTs
   * Use Command Line Tools to Complete PSBTs
   * Use HWI to Interact with a Hardware Wallet
   
Supporting objectives include the ability to:

   * Understand How PSBTs Differ from Multisignatures
   * Understand the Full Workflow of Working with PSBTs
   * Plan for the Power of PSBTs
   * Understand The Use of a Hardware Wallet
   
## Table of Contents

   * [Section One: Creating a Partially Signed Bitcoin Transaction](07_1_Creating_a_Partially_Signed_Bitcoin_Transaction.md)
   * [Section Two: Using a Partially Signed Bitcoin Transaction](07_2_Using_a_Partially_Signed_Bitcoin_Transaction.md)
   * [Section Three: Integrating with Hardware Wallets](07_3_Integrating_with_Hardware_Wallets.md)
   
