# Chapter 10: Embedding Bitcoin Scripts in P2SH Transactions

Bitcoin Script moves down several levels of abstraction, allowing you to minutely control the redemption conditions of Bitcoin funds. But, how do you actually incorporate those Bitcoin Scripts into the transactions you've been building to date? The answer is a new sort of Bitcoin transaction, the P2SH.

## Objectives for This Chapter

After working through this chapter, a developer will be able to:

   * Design a P2SH Transaction
   * Apply a P2SH Bitcoin Script
   
Supporting objectives include the ability to:

   * Understand the P2SH Script
   * Understand the Multisig Script
   * Understand the Various Segwit Variations of Scripts
   * Understand How to Spend Funds Sent to a P2SH
   
## Table of Contents

* [Section One: Understanding the Foundation of P2SH](10_1_Understanding_the_Foundation_of_P2SH.md)
* [Section Two: Building the Structure of P2SH](10_2_Building_the_Structure_of_P2SH.md)  
* [Section Three: Running a Bitcoin Script with P2SH](10_3_Running_a_Bitcoin_Script_with_P2SH.md)
* [Section Four: Scripting a Multisig](10_4_Scripting_a_Multisig.md)
* [Section Five: Scripting a Segwit Script](10_5_Scripting_a_Segwit_Script.md)
* [Section Six: Spending a P2SH Transaction](10_6_Spending_a_P2SH_Transaction.md)
