# Capítulo Tres: Entendiendo Su Configuración Bitcoin

Ahora está listo para comenzar a trabajar con la interfaz de línea de comandos `bitcoin-cli`. Pero eso primero requiere que comprenda la configuración de Bitcoin y las características de su billetera, que es lo que se explicará en este capítulo.

Para este y futuros capítulos, suponemos que tiene un VPS con Bitcoin instalado, ejecutando `bitcoind`. También suponemos que está conectado a testnet, lo que le permite acceder a bitcoins sin utilizar fondos reales. Puede hacerlo con Bitcoin Standup en Linode.com, según  [§2.1: Configuración de un Servidor Privado Virtual de Bitcoin-Core con Bitcoin Standup](02_1_Configurando_un_Bitcoin-Core_VPS_con_StackScript.md), o por otros medios, según [§2.2: Configuración de una Maquina Bitcoin-Core por Otros Medios](02_2_Configurando_Bitcoin_Core_Otros.md).

## Objetivos de este capítulo

Después de trabajar en este capítulo, un desarrollador podrá:

   * Demostrar que su nodo Bitcoin está instalado y actualizado
   * Crear una dirección para recibir fondos de Bitcoin
   * Usar comandos básicos de billetera
   * Crear una dirección a partir de un descriptor
   
Los objetivos de apoyo incluyen la capacidad de:

   * Comprender el diseño básico de archivos de Bitcoin
   * Usar comandos informativos básicos
   * Comprenda qué es una dirección de Bitcoin
   * Comprender qué es una billetera
   * Comprender cómo importar direcciones
   
## Tabla de contenido

* [Sección Uno: Verificando Su Configuración Bitcoin](03_1_Verificando_Su_Configuracion_Bitcoin.md)
* [Sección Dos: Conociendo Su Configuración Bitcoin](03_2_Conociendo_Su_Configuracion_Bitcoin.md)
* [Sección Tres: Configurando Su Billetera](03_3_Configurando_Su_Billetera.md)
   * [Interludio: Usando Variables de la Linea de Comandos](03_3_Interludio_Usando_Variables_Linea_Comando.md)
* [Sección Cuatro: Recibiendo una Transacción](03_4_Recibiendo_una_Transaccion.md)
* [Sección Cinco: Entendiendo El Descriptor](03_5_Entendiendo_El_Descriptor.md)
