# Capítulo 4: Enviando Transações no Bitcoin

Este capítulo descreve três métodos diferentes para enviar bitcoins para endereços P2PKH normais à partir da linha de comando, usando apenas o ```bitcoin-cli```.

## Objetivos deste Capítulo

Depois de trabalhar neste capítulo, um desenvolvedor será capaz de:

   * Decidir como enviar dinheiro usando o Bitcoin;
   * Criar uma transação bruta;
   * Usar aritmética para calcular as taxas.
   
Os objetivos secundários incluem a capacidade de:

   * Compreender transações e taxas de transação;
   * Entender as transações ```legacy``` e ```SegWit```;
   * Usar métodos básicos para enviar dinheiro;
   * Usar métodos de cálculo de taxa automática para enviar dinheiro;
   * Entender os perigos de transações brutas.
   
## Tabela de Conteúdo
  
  * [Seção 1: Enviando Moedas da Maneira Fácil](04_1_Sending_Coins_The_Easy_Way.md)
  * [Seção 2: Criando uma Transação Bruta](04_2_Creating_a_Raw_Transaction.md)
     * [Prefácio: Usando JQ](04_2__Interlude_Using_JQ.md)
  * [Seção 3: Criando uma Transação Bruta com Argumentos Nomeados](04_3_Creating_a_Raw_Transaction_with_Named_Arguments.md)
  * [Seção 4: Enviando Moedas com Transações Brutas](04_4_Sending_Coins_with_a_Raw_Transaction.md)
  * [Seção 5: Enviando Moedas com Transações Brutas Automatizadas](04_5_Sending_Coins_with_Automated_Raw_Transactions.md)
  * [Seção 6: Criando uma Transação SegWit](04_6_Creating_a_Segwit_Transaction.md)