# Capítulo 6: Expandindo Transações no Bitcoin com Multisigs

Transações básicas no Bitcoin: (1) enviam fundos; (2) para um único destinatário P2PKH ou SegWit; (3) de uma única máquina; (4) imediatamente. No entanto, todas as quatro partes desta definição podem ser expandidas usando transações mais complexas no Bitcoin. Este primeiro capítulo sobre "Expansão" mostra como variar os pontos (2) e (3) enviando saldos para um endereço que representa vários destinatários (ou, pelo menos, vários assinantes).

## Objetivos deste Capítulo

Depois de trabalhar neste capítulo, um desenvolvedor será capaz de:
   * Criar endereços de Bitcoin multi-assinatura (multisig) usando os fundamentos do Bitcoin;
   * Criar endereços de Bitcoin multi-assinatura (multisig) usando mecanismos mais fáceis.
   
Os objetivos secundários do capítulo incluem a capacidade de:
   * Entender como gastar fundos enviados para um multisig;
   * Planejar para obter o máximo do poder dos multisigs.
   
## Tabela de Conteúdo

   * [Seção 1: Enviando uma Transação com Multsig](06_1_Sending_a_Transaction_to_a_Multisig.md)
   * [Seção 2: Gastando uma Transação com Multsig](06_2_Spending_a_Transaction_to_a_Multisig.md)
   * [Seção 3: Enviando & Gastando um Multisig Automatizado](06_3_Sending_an_Automated_Multisig.md)