# Capítulo Sete: Expandindo Transações no Bitcoin com PSBTs

No capítulo anterior, discutimos como usar os multisigs para determinar colaborativamente o consentimento entre várias partes. Essa não é a única forma de colaborar na criação de transações no Bitcoin. Os PSBTs são uma tecnologia muito mais recente que permite que colaboremos em vários estágios, incluindo a criação, financiamento e autenticação de uma transação Bitcoin.

## Objetivos para Esta Seção

Depois de trabalhar neste capítulo, um desenvolvedor será capaz de:

   * Criar transações com PSBTs;
   * Usas ferramentas da linha de comando para completar PSBTs;
   * Usar o HWI para interagir com uma hardware wallet.
   
Os objetivos secundários do capítulo incluem a capacidade de:

   * Entender como os PSBTs diferem dos multisig;
   * Compreender completamente o fluxo de trabalho com os PSBTs;
   * Planejar para todo o poder dos PSBTs;
   * Compreender o uso de uma hardware wallet.
  
## Tabela de Conteúdo

   * [Seção Um: Criando uma Transação Parcialmente Assinada no Bitcoin (PSBT)](07_1_Creating_a_Partially_Signed_Bitcoin_Transaction.md)
   * [Seção Dois: Usando uma Transação Parcialmente Assinada no Bitcoin (PSBT)](07_2_Using_a_Partially_Signed_Bitcoin_Transaction.md)
   * [Seção Três: Integrando com Hardware Wallets](07_3_Integrating_with_Hardware_Wallets.md)