# Capítulo 9: Apresentando os Scripts do Bitcoin

Até o momento, temos interagido com o Bitcoin em um nível relativamente alto de abstração. O programa ```bitcoin-cli``` oferece acesso a uma variedade de comandos RPC que suportam a criação e controle de transações brutas de Bitcoin que incluem saldos, dados, timelocks e multisigs.

No entanto, o Bitcoin oferece muito mais complexidade do que isso. O software oferece uma linguagem de script simples que pode ser usada para criar condições de resgate ainda mais complexas. Se os multisigs e os timelocks fornecerem as bases para os contratos inteligentes, o script do Bitcoin constrói os alicerces. É o próximo passo para capacitar o Bitcoin.

## Objetivos deste Capítulo

Depois de trabalhar neste capítulo, um desenvolvedor será capaz de:

   * Projetar um script no Bitcoin;
   * Aplicar um script no Bitcoin.

Os objetivos secundários do capítulo incluem a capacidade de:

   * Compreender o propósito dos scripts no Bitcoin;
   * Entender os script P2PKH;
   * Entender como o P2WPKH funciona com os scripts;
   * Compreender as necessidades dos testes dos scripts do bitcoin.

## Tabela de Conteúdo

* [Seção Um: Compreendendo a Base das Transações](09_1_PriveStanding_the_foundation_of_transactions.md)
* [Seção Dois: Executando um Script do Bitcoin](09_2_running_a_bitcoin_script.md)
* [Seção Três: Testando um Script do Bitcoin](09_3_testing_a_bitcoin_script.md)
* [Seção Quatro: Programando um P2PKH](09_4_scripting_a_p2pkh.md)
* [Seção Cinco: Programando um P2WPKH](09_5_scripting_a_p2wpkh.md)