# Capítulo 10: Incorporando Scripts em Transações P2SH no Bitcoin

O Bitcoin Script desce vários níveis de abstração, permitindo que controlemos minuciosamente as condições de resgate dos fundos. Mas, como realmente incorporamos esses scripts do Bitcoin nas transações que construímos até agora? A resposta é um novo tipo de transação de Bitcoin, o P2SH.

## Objetivos deste Capítulo

Depois de trabalhar neste capítulo, um desenvolvedor será capaz de:

   * Projetar uma transação P2SH;
   * Aplicar um script P2SH Bitcoin.

Os objetivos secundários do capítulo incluem a capacidade de:

   * Compreender o script P2SH;
   * Compreender o script Multisig;
   * Compreender as várias variações dos scripts Segwit;
   * Entender como gastar fundos enviados a um P2SH.

## Tabela de Conteúdo

* [Seção 1: Compreendendo a Base do P2SH](10_1_Understanding_the_Foundation_of_P2SH.md)
* [Seção 2: Construindo a Estrutura do P2SH](10_2_Building_the_Structure_of_P2SH.md)
* [Seção 3: Executando um Script do Bitcoin com P2SH](10_3_Running_a_Bitcoin_Script_with_P2SH.md)
* [Seção 4: Programando um Multisig](10_4_Scripting_a_Multisig.md)
* [Seção 5: Programando um Script Segwit](10_5_Scripting_a_Segwit_Script.md)
* [Seção 6: Gastando uma Transação P2SH](10_6_Spending_a_P2SH_Transaction.md)